heatingplants = {};

--needs heatingplants
--lineType 2/heatingplants
function heatingplants:load(heatingplantName)
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {lineTyp=1, txtScroll={leftRight=true,upDown=true}};
	if moModule.heatingplants ~= nil and #moModule.heatingplants > 0 then
		local deleteObject = {};
		for index=1, #moModule.heatingplants do		
			if moModule.heatingplants[index] ~= nil then
				local heatingplant = moModule.heatingplants[index];			
				local isObject = moModule:isObject(heatingplant.object)
				if isObject then
					if heatingplant.object.ownerFarmId == 0 or heatingplant.object.ownerFarmId == playerFarmId then
						if heatingplant.xmlName == heatingplantName then
							lineTable[#lineTable+1] = {};
							local isLineTable = lineTable[#lineTable];			
							
							if #moModule.heatingplants > 1 and index ~= 1 then					
								isLineTable.setLineBorderNewObject = true;	
							end;
							
							isLineTable.ownValues = {heatingplantName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].nodeId = heatingplant.object.nodeId;
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
							isLineTable.txt[1].bold = true;			
							local name = heatingplant.name;
							if heatingplant.mohDisplayName ~= nil then name = heatingplant.mohDisplayName;end;
							local isNearObject = moModule:nearPlayerPosition(heatingplant.object, 10);				
							if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = heatingplants.returnClickObjectName;end;	
							if isNearObject ~= nil and isNearObject then
								isLineTable.txt[1].txt = ">>".. name.. "<<";
							else
								isLineTable.txt[1].txt = name;
							end;
							isLineTable.txt[1].txtPos = 1;		
							
							
							--isLineTable.txt[1].width = 70;	--width prozent	
						end;
					end;
				else	
					table.insert(deleteObject, index);				
				end;		
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.heatingplants, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;	
	heatingplants[heatingplantName] = {output=lineTable};	
end;

function heatingplants.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local heatingplantName = args.ownValues[1];
			if heatingplants[heatingplantName] ~= nil and heatingplants[heatingplantName].output ~= nil and heatingplants[heatingplantName].output[args.line] ~= nil then
				local nodeId = heatingplants[heatingplantName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;			
		end;		
	end;
end;

function heatingplants.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		--moModule.active.heatingplants.isRunning = true;moModule.active.heatingplants.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local heatingplantName = args.ownValues[1];
			heatingplants:load(heatingplantName);
			return heatingplants[heatingplantName].output;
		end;
	end;
end;

function heatingplants.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--heatingplants:load();	
end;

function heatingplants:generateCmd(heatingplantName)
	local _, errorTable = 0, {};
	function inserCmd(heatingplantName)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local heatingplantNameTemp = tostring(heatingplantName):lower();
		local languageName = moLanguageXml:getTxt(heatingplantNameTemp, nil, heatingplantName);
		newCmdTable.cmdTable[1] = {
			cmdName = "heatingplants_".. tostring(heatingplantName);
			displayName = moLanguageXml:getTxt("heatingplants", nil, "Heatingplants").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "Heatingplants";
			infoTxt = "Zeigt alle Heizkarfwerke oder diese Category an (".. tostring(languageName).. ")";
			helpTxt = "View Heatingplants or Category";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = heatingplants.giveOutputTable; --a function
			ownValues = {heatingplantName}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate heatingplants Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if heatingplantName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "heatingplants_".. heatingplantName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(heatingplantName);end;
	else
		if moModule.heatingplants ~= nil and #moModule.heatingplants > 0 then
			for index=1, #moModule.heatingplants do
				local heatingplantName = moModule.heatingplants[index].xmlName;
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "heatingplants_".. heatingplantName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(heatingplantName);end;
			end;			
		end;
	end;
end;

